-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxilliary"
M.relevantDevice = nil

local min = math.min
local max = math.max

local targetAngle = 1
local lastFrameAngle = 1
local state = "idle"
local autoFire = false
local timer = 0

local timer2=1

local function updateGFX(dt)
  local tiltAngle = 0
  local sledPosition = 0
  timer = timer + dt

  targetAngle = min(max(targetAngle + (electrics.values.angle_change or 0) * dt * 0.1, 0), 1)

  if state == "idle" then
  
  elseif state == "prepare" then
    tiltAngle = targetAngle
    if autoFire and timer > 1 then
      timer = 0
      state = "fire"
    end
  elseif state == "fire" then
    tiltAngle = targetAngle
    sledPosition = 1
    if timer > timer2 then
      timer = 0
      state = "idle"
    end
  end

  if targetAngle ~= lastFrameAngle then
    guihooks.message(string.format("Tilt angle: %d%%", targetAngle * 100), 1, "targetangle")
    lastFrameAngle = targetAngle
  end

  electrics.values.tilt_position = tiltAngle
  electrics.values.sled_position = -sledPosition
end

local function cycle()
  if state == "idle" then
    state = "prepare"
    autoFire = true
    timer = 0
  elseif state == "prepare" and autoFire == false then
    state = "fire"
    timer = 0
  end
end

local function prepare()
  state = state == "idle" and "prepare" or "idle"
  autoFire = false
  timer = 0
end

local function init(jbeamData)
  state = "idle"
  timer = 0
  autoFire = false
  timer2 = jbeamData.timer or 3
end

M.init = init
M.updateGFX = updateGFX
M.cycle = cycle
M.prepare = prepare

return M